#include <pthread.h>
#include <stdio.h>
#define NUM_THREADS     5

struct thread_data{
   int  thread_id;
   int  sum;
   char message[1024];
};

struct thread_data thread_data_array[NUM_THREADS];


void *PrintHello(void *threadarg)
{
  int taskid;
  char* hello_msg;
  int sum;
  struct thread_data *my_data;
   my_data = (struct thread_data *) threadarg;
   taskid = my_data->thread_id;
   sum = my_data->sum;
   hello_msg = my_data->message;

  printf("%s It's me, thread #%ld!\n", hello_msg, taskid);
  pthread_exit(NULL);
}


int main (int argc, char *argv[])
{
  pthread_t threads[NUM_THREADS];
  int rc;
  long t;
  for(t=0; t<NUM_THREADS; t++){
    printf("In main: creating thread %ld\n", t);
    
    thread_data_array[t].thread_id = t;
    thread_data_array[t].sum = t;
    sprintf (thread_data_array[t].message, "Hello from thread %d ...", t);
    printf("Creating thread %ld\n", t);
    rc = pthread_create(&threads[t], NULL, PrintHello, 
			(void *) &thread_data_array[t]);

    if (rc){
      printf("ERROR; return code from pthread_create() is %d\n", rc);
      exit(-1);
    }
  }
  pthread_exit(NULL);
}
